/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * d_printf.h: debugging messages. Can be easily compiled out by
 *   setting the -DNDEBUG flag. Verbosity level controlled by setting
 *   the environment variable DEBUG_LEVEL. If DEBUG_LEVEL = -1, then
 *   _all_ debugging messages will be printed. Otherwise, only those
 *   messages with a debug level less than DEBUG_LEVEL will be printed
 *   (so DEBUG_LEVEL = 0 produces no messages).
 *
 * $Id$
 */

#ifndef _SNAP_DPRINTF_H_
#define _SNAP_DPRINTF_H_

#ifdef __KERNEL__
#include <linux/config.h>
#include <linux/kernel.h>
#else
#include <stdio.h>
#endif /* __KERNEL__ */

#ifdef __KERNEL__
#ifdef CONFIG_IP_SNAP_DEBUG
#define d_printf(lvl,fmt,arg...) printk(KERN_WARNING fmt,##arg)
#else
#define d_printf(lvl,fmt,arg...)
#endif /* CONFIG_IP_SNAP_DEBUG */

#else


#ifdef NDEBUG
#define d_printf
#else
extern int debug_level;
extern void _dprintf_func(int lvl, char *fmt, ...);
#define d_printf _dprintf_func
#endif /* NDEBUG */

#endif /* __KERNEL__ */
#endif /* !_SNAP_DPRINTF_H_ */
