/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * deliver.c: allow a SNAP program to deliver data to an application
 *   via a UDP socket
 *
 * $Id$
 */

#include <errno.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>
#include "d_printf.h"

void deliver(int portnum, char *data, int data_lenb) {
  struct sockaddr_in local_addr;
  int appsock;
  int bytes_sent;

  if ((appsock = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
    perror("deliver: socket");
    return;
  }
  
  local_addr.sin_family = AF_INET;
  local_addr.sin_port = portnum;
  local_addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
  
  while((bytes_sent = sendto(appsock, data, data_lenb, 0,
			     (struct sockaddr *)&local_addr,
			     sizeof(local_addr))) == -1 &&
	errno == ECONNREFUSED);
  if (bytes_sent == -1) {
    perror("deliver: sendto");
    return;
  }
  d_printf(150,"%s:%d: wrote %d bytes to local UDP port %d\n",
	   __FILE__,__LINE__,data_lenb,portnum);
  close(appsock);
  return;
}
