/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * dyncheck.h : defines dynamic safety checks which can be compiled
 *   out if desired with -DNDYNCHECK
 *
 * $Id$
 */

#ifndef _SNAP_DYNCHECK_H_
#define _SNAP_DYNCHECK_H_

#ifdef __KERNEL__
#include <linux/kernel.h>
#define __STRING(x) #x
#endif /* __KERNEL__ */

#ifndef NDYNCHECK
#ifndef __KERNEL__
#define DYNCHECK_RET(expr,retv)                                             \
  { if (!(expr)) {                                                          \
      fprintf(stderr,"%s:%d: dynamic check '%s' failed, dropping packet\n", \
              __FILE__,__LINE__,__STRING(expr));                            \
      fflush(stderr);                                                       \
      return (retv);                                                        \
    }                                                                       \
  }
#else
#define DYNCHECK_RET(expr,retv)                                             \
  { if (!(expr)) {                                                          \
      printk(KERN_WARNING "%s:%d: dynamic check '%s' failed, dropping packet\n", \
              __FILE__,__LINE__,__STRING(expr));                            \
      return (retv);                                                        \
    }                                                                       \
  }
#endif /* !__KERNEL__ */
#define DYNCHECK(expr) DYNCHECK_RET(expr,-1)
#else
#define DYNCHECK(expr) /**/
#define DYNCHECK_RET(expr,retv) /**/
#endif /* !NDYNCHECK */


#endif /* !_SNAP_DYNCHECK_H_ */
