/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * io.h : interface to marshalling and unmarshalling routines.
 *
 * $Id$
 */

#ifdef __KERNEL__
#include <linux/skbuff.h>
#include <snap/bytecode.h>
#include <snap/packet.h>
#else
#include "bytecode.h"
#include "packet.h"
#endif /* __KERNEL__ */

#ifndef _SNAP_IO_H_
#define _SNAP_IO_H_

typedef struct {
  int lenb;
  char *s;
} buffer_t;

#ifndef __KERNEL__

extern packet_t *unmarshal_packet(char *buffer, int packet_lenb, int buf_lenb);
extern void marshal_packet(packet_t *p, int stack_amt, buffer_t *bufstr);
int file_to_str(int fd, buffer_t *buf);

#else

extern int unmarshal_packet(packet_t **p, struct sk_buff *skb);
extern int marshal_packet(struct sk_buff **skbp, packet_t *p, unsigned
			  int stack_amt);

#endif /* __KERNEL__ */

#endif /* !_SNAP_IO_H_ */

