/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * lextest.c : test program for exercising the SNAP lexer.
 *
 * $Id$
 */

#include <stdio.h>
#include "memalloc.h"
#include "snapparse.h"
#include "packet.h"

#define HEAPSIZEB (1024 * 1024)

extern int yylex(void);
extern int yydebug;
int noop=0;

packet_t *p;
char heap[HEAPSIZEB];

int main(int argc, char **argv) {
  unsigned int tok;
  
  memalloc(p,packet_t *,sizeof(packet_t));
  p->heap_min = heap;
  p->h_alloc_ptr = heap;
  p->heap_max = &heap[HEAPSIZEB];
  tok = yylex();
  while(tok) {
    printf("token %d\n",tok);
    tok = yylex();
  }
  return(0);
}
