/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * packet.c : routines for debugging output of SNAP packets
 *
 * $Id$
 */

#include <netinet/in.h>
#include <stdio.h>
#include "bytecode.h"
#include "packet.h"

void fprintf_packet(FILE *outfile,packet_t *p) {
  instr_t *codeptr;
  value_t *stackptr;
  unsigned int inum, entry_point;

  fprintf(outfile,"#dst\t");
  fprintf_addr(outfile,p->hdr->dst);
  fprintf(outfile,"\n#src\t");
  fprintf_addr(outfile,p->hdr->src);
  fprintf(outfile,"\n");
  fprintf(outfile,"#rb\t%d\n",ntohs(p->hdr->rb));
  fprintf(outfile,"#sport\t%d\n",ntohs(p->hdr->sport));
  
  codeptr = p->code_min;
  inum = 0;
  entry_point = ntohs(p->hdr->entry_point);
  while(codeptr < p->code_max) {
    if (inum == entry_point) {
      fprintf(outfile,"main:\n");
    }
    fprintf(outfile,"\t");
    fprintf_instr(p->heap_min,outfile,codeptr);
    fprintf(outfile,"\n");
    codeptr++;
    inum++;
  }
  
  stackptr = p->stack_min;
  while(stackptr < p->sp) {
    fprintf(outfile,"#data\t");
    fprintf_value(p->heap_min,outfile,stackptr);
    fprintf(outfile,"\n");
    stackptr++;
  }
}
