/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * updfwd.c : basically a UDP-layer router, useful for performance
 *   comparisons against SNAP user-space daemons.
 *
 * $Id$
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include "memalloc.h"
#include "packet.h"
#include "timers.h"
#include "router.h"

int udp_port = 7777;
int sock;
struct sockaddr_in myaddr;
struct sockaddr_in hopaddr;
char *buf = NULL;
int buf_sizeb = 10 * 1024;

int main() {
  int *hop;
  struct sockaddr fromaddr;
  int fromlen = sizeof(fromaddr);
  
  myaddr.sin_family = AF_INET;
  myaddr.sin_port = udp_port;
  myaddr.sin_addr.s_addr = htonl(INADDR_ANY);

  hopaddr.sin_family = AF_INET;
  hopaddr.sin_port = udp_port;

  memalloc(buf,char *,buf_sizeb);
  if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }
  if (bind(sock,&myaddr,sizeof(myaddr)) == -1) {
    perror("bind");
    exit(1);
  }

  read_routes();
  while(1) {
    int len;
    int outb;
    unsigned int the_hop;
    header_t *h;
    len = recvfrom(sock,buf,buf_sizeb,0,&fromaddr,&fromlen);
    if (len == -1 && errno == ECONNREFUSED)
      continue;
    if (len == -1) {
      perror("recvfrom");
      exit(1);
    }
    h = (header_t *)buf;
    hop = nexthop(h->dst);
    if (hop == NULL) {
      fprintf(stderr,"no route to host\n");
      exit(1);
    }
    if (*hop == 0) {
      the_hop = h->dst;
    } else {
      the_hop = *hop;
    }
    hopaddr.sin_addr.s_addr = the_hop;
    while((outb = sendto(sock,buf,len,0,&hopaddr,sizeof(hopaddr)))
	  == -1 && errno == ECONNREFUSED);
    if (outb == -1) {
      perror("sendto");
      exit(1);
    }
  }
  return(0);
}
  
