/* snap-1.0. Copyright (C) 2000 by Jonathan T. Moore and Michael Hicks.
 *
 * wassert.h : implementation of `soft' assert statements
 *
 * $Id$
 */

#ifndef _SNAP_WASSERT_H_
#define _SNAP_WASSERT_H_

/* Defines a special kind of assert that prints a warning but allows
   execution to continue.  Used to signal problems with the packet,
   but does not halt execution (i.e., packet is ill-formed, but this
   does not constitute an internal error). */
#ifndef NDEBUG

#define wassert(e)							\
  if (e); 								\
  else { 								\
    fprintf(stderr,"%s:%d: soft-assertion failed in %s\n",		\
	    __FILE__,__LINE__,__STRING(e));				\
  }

#else

#define wassert(e) ((void) 0)

#endif

#endif /* _SNAP_WASSERT_H_ */
